//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DBDateTimePicker.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TDBDateTimePicker *)
{
  new TDBDateTimePicker(NULL);
}
//---------------------------------------------------------------------------

// Constructor

__fastcall TDBDateTimePicker::TDBDateTimePicker(TComponent* Owner)
        : TDateTimePicker(Owner)
{
  FDataLink = new TFieldDataLink();
  FDataLink->Control = this;
  FDataLink->OnDataChange = DataChange;
  FDataLink->OnUpdateData = UpdateData;

  TDateTimePicker::OnDropDown = DropDown;

  ShowToday       = false;
  ShowTodayCircle = false;

  // ControlStyle := ControlStyle + [csReplicatable];
  // FDataLink->OnEditingChange = EditingChange;
}

// Destructor

__fastcall TDBDateTimePicker::~TDBDateTimePicker(void)
{
  FDataLink->Control = NULL;
  FDataLink->OnDataChange = NULL;
  FDataLink->OnUpdateData = NULL;
  delete FDataLink;
  FDataLink = NULL;
}

// Eventos

void __fastcall TDBDateTimePicker::Change()
{
  TDateTimePicker::Change(); // inherited method

  if (FDataLink != NULL)
     FDataLink->Modified();
}

void __fastcall TDBDateTimePicker::DropDown(TObject *sender)
{
  if (!GetReadOnly())
     FDataLink->Edit();
}

void __fastcall TDBDateTimePicker::MouseDown(TMouseButton Button, TShiftState Shift, int  X, int Y)
{
  TMouseEvent MyMouseDown;

  if (!GetReadOnly() && FDataLink->Edit()) {            // if the field can be edited
     TDateTimePicker::MouseDown(Button, Shift, X, Y);   // call the inherited MouseDown
  } else {
    MyMouseDown = OnMouseDown;
    if (MyMouseDown != NULL)                            // execute code in the...
       MyMouseDown(this, Button,Shift, X, Y);           // ...OnMouseDown event handler
  }
}

void __fastcall TDBDateTimePicker::KeyDown(unsigned short &Key, TShiftState Shift)
{
  TKeyEvent MyKeyDown;                                // declare event type
/*
  Set<unsigned short,0,8> keySet;

  keySet = keySet << VK_UP << VK_DOWN << VK_LEFT      // assign virtual keys to set
    << VK_RIGHT << VK_END << VK_HOME << VK_PRIOR << VK_NEXT;
*/
  if (!GetReadOnly() &&                           // if control is not read only...
      //(keySet.Contains(Key)) &&                 // ...and key is in the set...
      FDataLink->Edit() ) {                       // ...and field is in edit mode
      TDateTimePicker::KeyDown(Key, Shift);       // call the inherited KeyDown method
  } else {
      MyKeyDown = OnKeyDown;                // assign OnKeyDown event
      if (MyKeyDown != NULL)                // execute code in...
         MyKeyDown(this,Key,Shift);         // ...OnKeyDown event handler
  }
}

void __fastcall TDBDateTimePicker::CMExit(TWMNoParams &Message)
{
  try {
    FDataLink->UpdateRecord();         // tell data link to update database
  } catch(...) {
    SetFocus();                        // if it failed, dont let focus leave
    throw;
  }
}

void __fastcall TDBDateTimePicker::DataChange(System::TObject* Sender)
{
  if (FDataLink->Field!=NULL)
     Date = FDataLink->Field->AsDateTime;
}

void __fastcall TDBDateTimePicker::UpdateData(System::TObject* Sender)
{
  FDataLink->Field->AsDateTime = Date;
}

// Propiedades

AnsiString __fastcall TDBDateTimePicker::GetDataField()
{
  return FDataLink->FieldName;
}

void __fastcall TDBDateTimePicker::SetDataField(const AnsiString Value)
{
  FDataLink->FieldName = Value;
}

Db::TDataSource* __fastcall TDBDateTimePicker::GetDataSource(void)
{
  return FDataLink->DataSource;
}

void __fastcall TDBDateTimePicker::SetDataSource(Db::TDataSource* Value)
{
  if (!FDataLink->DataSourceFixed) /*&& (csLoading in ComponentState)*/
     FDataLink->DataSource = Value;

  if (Value!=NULL)
     Value->FreeNotification(this);
}

Db::TField* __fastcall TDBDateTimePicker::GetField(void)
{
  return FDataLink->Field;
}


bool __fastcall TDBDateTimePicker::GetReadOnly(void)
{
  return FDataLink->ReadOnly;
}

void __fastcall TDBDateTimePicker::SetReadOnly(bool Value)
{
  FDataLink->ReadOnly = Value;
}

// TDateTimePicker

void __fastcall TDBDateTimePicker::CheckEmptyDate(void)
{
  Invalidate();
}


//---------------------------------------------------------------------------
namespace Dbdatetimepicker
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TDBDateTimePicker)};
                 RegisterComponents("Samples", classes, 0);
        }
}
//---------------------------------------------------------------------------



